/* Author: Nathan Zorndorf
 * Description: Audio to MIDI converter. 
 * modified by Tyler Olivieri
 * for graphic EQ (spectrum analyzer)
 */
//#include <csl_uart.h>
#include <stdio.h>
#include <math.h> 
#include <tms320.h>
#include <Dsplib.h>
#include <my_types.h>
#include <usbstk5505.h>
#include <Application_1_Modified_Registers.h>
#include <My_PLL.h>
#include <My_I2C.h> 
#include <My_AIC3204.h>
#include <My_I2S_Register.h>
#include <My_DMA_Ping_Pong_Register_Setup.h>
#include <My_UART.h>

#include <Audio_Straight_Through_Using_DMA.h>
//#include "spectrumAnalyzer_DMA_cfft.h"
//#include "spectrumAnalyzer_dma_hwfft.h"
//#include "tyler_FIR_uart.h"


// Buffers for DMA in/out and overlap-add 
//Ref: barrgroup.com/Embedded-Systems/How-To/C-Volatile-Keyword
//Gloval variables modified by an interrupt service routine should be declared volatile
Int16 volatile PingPongFlagInL;
Int16 volatile PingPongFlagInR;
Int16 volatile PingPongFlagOutL;
Int16 volatile PingPongFlagOutR;
Int16 volatile overLapOutFlag;
Int16 volatile doneFlag;
Int16 volatile straightThroughFlag;


//Int16 OverlapInL[WND_LEN];
//Int16 OverlapInR[WND_LEN];
//Int16 OverlapOutL[OVERLAP_LENGTH];
//Int16 OverlapOutR[OVERLAP_LENGTH];
/*
/* --- buffers required for processing  ----*/
//#pragma DATA_SECTION(BufferL,"BufL");
//Int16 BufferL[FFT_LENGTH];
//#pragma DATA_SECTION(BufferR,"BufR");
//Int16 BufferR[FFT_LENGTH];
/* -------------------------------------------*/

Int16 DMA_InpL[PING_PONG_SIZE];
Int16 DMA_InpR[PING_PONG_SIZE];
Int16 DMA_OutL[PING_PONG_SIZE];
Int16 DMA_OutR[PING_PONG_SIZE];


int main(void) {
	
 	My_PLL();
    
 	IER0 = 0xC100; // DMA, I2S RX/TX Interrupt Enable. 

 	    
 	My_I2C();
 	 
 	My_AIC3204();

	My_DMA_Ping_Pong_Register_Setup();

	My_UART(); // setup UART and transmit test sequence
	
	
	My_I2S_Register();
	
	Audio_Straight_Through_Using_DMA(); // just to test everything is working before moving onto the real deal
	
	//spectrumAnalyzer_DMA_hwfft();
	//spectrumAnalyzer_DMA_cfft();

	
   	
   	
	printf("Reached end of main!\n");
	
 	return(1);
}









